#!/usr/bin/perl

# Perl 5 is needed (because of readline)

# This is a program which takes a given input file, and hashes each line of
# it to the output.

# The hash is the Marahash program which comes with the 1.0.x branch of
# MaraDNS

$tmpdir = $ENV{"HOME"} . "/tmp";

# One-way hash so spammers can not use this list as a source of emails
sub hash {
	my($p) = @_;
	open(P,"xhasher '$p' |") || die "Marahash $!";
	$r = readline(P);
	chop($r);
	close(P);
	return $r;
	}

# Routine which gets an all-lower-case email address from a given from
# line

sub getfrom {
	my($i) = @_;
	# Get first word with @ in it
	if($i =~ /\b(\S+\@\S+)\b/) {
	    $i = $1;
	    }
	# Make all lower case
	$i =~ tr/A-Z/a-z/;
	# Get rid of anything between a '+' or '-' and the @ symbol, for
	# people who change tags for antispam purposes
	$i =~ s/\-[^@]*\@/-@/;
	$i =~ s/\+[^@]*\@/+@/;
	# Hash it for spam protection
	if($i) {
		$i = hash($i);
		}
	# Return our value
	return $i;	
	}

while(<>) {
	chop;
	print getfrom($_) . "\n";
	}

