#!/usr/bin/perl

# Perl 5 is needed (because of readline)

# This is a script which does the following:

# Output a hashed email address and the first time said email address
# posted to the news group (value "190288909" for email addresses which
# have been "grandfathered in")

# This can be run from any directory.

$dir = "/var/spool/news";
$newsgroup = "comp/unix/admin";
$xdir = "/usr/local/xkook";

# One-way hash so spammers can not use this list as a source of emails
sub hash {
	my($p) = @_;
	my($r);
	open(P,"xhasher $p |") || die "xhasher $!";
	$r = readline(P);
	chop($r);
	my($a) = split(/\s+/,$r);
	close(P);
	return $a;
	}

# Routine which gets an all-lower-case email address from a given from
# line

sub xfrom {
	my($i) = @_;
	# Get first word with @ in it
	if($i =~ /\b(\S+\@\S+)\b/) {
	    $i = $1;
	    }
	# Make all lower case
	$i =~ tr/A-Z/a-z/;
	# Get rid of anything between a '+' or '-' and the @ symbol, for
	# people who change tags for antispam purposes
	$i =~ s/\-[^@]*\@/-@/;
	$i =~ s/\+[^@]*\@/+@/;
	# Return our value
	return $i;	
	}

# Routine which hashes a given line with an email address, hashing only the
# email address

sub getfrom {
	my($i) = @_;
	$i = xfrom($i);
	$i = hash($i);
	return $i;
	}

# Routine, which when given a filename (article number) to look
# at, determines who posted the reply.  Returns the hased email address
# and the ctime of the article in question

sub lookat {
	my($filename) = @_;
	open(F,"< $filename") || return;
	$inheader = 1;
	while(<F>) {
		chop;
		$line = $_;
		if(/^\s+$/) {
			$inheader = 0;
			$inrefs = 0;
			}
		if(s/^From:\s*//i && $inheader) {
			$from = getfrom($line);
			#$x = xfrom($line);
			}
		}
	if(!$email{$from}) {
	    ($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,
	     $atime,$mtime,$ctime,$blksize,$blocks) = stat($filename);
            print "$from $ctime\n";
	    $email{$from} = $ctime;
	    }
	}

# Get a list of people who are in the "already replied" list
%email = ();
open(F,"< $dir/x.kook/already.seen") || die;
while(<F>) {
	# Zap comments from processing
	s/\#.*$//;
	my($hash,$pt) = split(/\s+/,$_);
	if($hash) {	
		$email{$hash} = "190288909";
		}
	}

# Determine which files to look at
$max = 0;
open(F,"< $dir/x.kook/high.article.number") || die;
$max = readline(F);
print "Max: $max\n";
close(F);

chdir("$dir/$newsgroup");
opendir(F,".");
@filelist = readdir(F);
closedir(F);

# Look at those files (newsgroup postings)
foreach $file (@filelist) {
	if($file =~ /^\d+$/ && $file > $max) {
	        lookat($file);
		$max = $file;	
		}
	}

