#!/usr/bin/perl

# Perl 5 is needed (because of readline)

# This is the core engine which does the following:
# * Erases any and all replies to any of a resident troll's postings
# * Posts an autoreply for people who 
#   a) Reply to one of the troll's postings
#   b) Have never replied to one of his postings before

$dir = "/var/spool/news";
$newsgroup = "comp/unix/admin";
$xdir = "/usr/local/xkook";
$tmpdir = $ENV{"HOME"} . "/tmp";

# One-way hash so spammers can not use this list as a source of emails
sub hash {
	my($p) = @_;
	my($r);
	open(P,"xhasher $p |") || die "Marahash $!";
	$r = readline(P);
	chop($r);
	my($a) = split(/\s+/,$r);
	close(P);
	return $a;
	}

# Routine which gets an all-lower-case email address from a given from
# line

sub xfrom {
	my($i) = @_;
	# Get first word with @ in it
	if($i =~ /\b(\S+\@\S+)\b/) {
	    $i = $1;
	    }
	# Make all lower case
	$i =~ tr/A-Z/a-z/;
	# Get rid of anything between a '+' or '-' and the @ symbol, for
	# people who change tags for antispam purposes
	$i =~ s/\-[^@]*\@/-@/;
	$i =~ s/\+[^@]*\@/+@/;
	# Hash it for spam protection
	# Return our value
	return $i;	
	}

# Routine which hashes a given line with an email address, hashing only the
# email address

sub getfrom {
	my($i) = @_;
	$i = xfrom($i);
	$i = hash($i);
	return $i;
	}

# Routine, when given the from, subject line, the References line, the
# newsgroups line, and the message-id for a given posting, pipes a reply 
# to them, but only if this
# person has never responded to our troll before
sub reply {
	my($f,$s,$r,$ng,$m) = @_;
	# If they have already replied to the kook, do nothing
	my($h) = (getfrom($f));
	my($t);
	if(!$h) {
		return;
		}
	if($email{$h}) {
		print "$f has already seen troll\n";
		return;
		}
        # We only auto-reply once every seven days
	open(A,"< $dir/x.kook/lastreply") || die "Cant get lastreply $!\n";
	while(<A>) {
	    chop;
	    if(/^(\d+)/) {
	        $t = $1;
		}
            }
        close(A);
        if($t > time() - (86400 * 7)) {
	    print "Last autoreply posted too soon\n";
	    return;
	    }
        # Post the article
	open(I,"| $xdir/inews-xkook") || die "Cant run inews $!\n";
	#open(I,"| /bin/cat") || die "Cant run inews $!\n";
	open(A,"< $xdir/autoreply") || die "autoreply $!\n";
	print I $r . " " . $m . "\n";
	print I $s . "\n";
	print I $ng . "\n";
	while(<A>) {
		print I $_;
		}
	close(A);
	print "About to post auto-reply\n";
	close(I);
	# Add the person's name to people who got the reply
	print "Adding $f to replied list\n";
	open(A,">> $dir/x.kook/already.seen");
	my($q) = getfrom($f) . " $f\n";
	print A $q;
	close(A);
	# Update the timestmap of the last reply
	open(A,">> $dir/x.kook/lastreply") || die "lastreply $!\n";
	print A time() . "\n";
	return;
	}

# Routine, which when given a filename (article number) to look
# at, determines whether it is a reply to one of the troll's postings.
# If so, it deletes the file.  If the replier in question has never
# replied to the troll before, give the replier in question an auto-reply,
# which is posted for the benefit of the lurkers

sub lookat {
	my($filename) = @_;
	open(F,"< $filename") || return;
	$inheader = 1;
	$inrefs = 0;
	$reflist = "";
	$subject = "Subject: Re: [no subject specified]";
	while(<F>) {
		chop;
		$line = $_;
		if(/^\s+$/) {
			$inheader = 0;
			$inrefs = 0;
			}
		if(/^References:/i && $inheader) {
			$inrefs = 1;
			}
		elsif(/^\S+:/) {
			$inrefs = 0;
			}
		if(/^Subject:/i && $inheader) {
			$subject = $line;
			}
		if(/^Newsgroups:/i && $inheader) {
			$newsgroups = $line;
			}
		if(s/^Message\-id:\s*//i && $inheader) {
			$messageid = $line;
			$messageid =~ s/^Message\-id:\s*//i;
			}
		if(s/^From:\s*//i && $inheader) {
			$from = xfrom($line);
			}
		if($inrefs) {
			$reflist .= $line;
			}
		}
	foreach $id (@messages) {
		my($t,$m) = split(/:/,$id);
		if($m && $reflist =~ /$m/) {
			print "$filename refs kook\n";
			# No, I don't want to see the troop
			unlink($filename);
			}
		if($m && $reflist =~ /$m\s*$/) {
			print "$filename replies to kook\n";
			# Give them a reply, as needed
			reply($from,$subject,$reflist,$newsgroups,$messageid);
			}
		}
	}

# Get the message IDs of the troll's postings
@messages = "";
open(F,"< $dir/x.kook/message.id");
while(<F>) {
	chop;
	if(/^\d+:/) {
		@messages = (@messages, $_);
		}
	}

# Make a list of people who have already posted
%email = ();
open(F,"< $dir/x.kook/already.seen") || die;
while(<F>) {
	# Zap comments from processing
	s/\#.*$//;
	my($hash,$pt) = split(/\s+/,$_);
	if($hash) {	
		$email{$hash} = $pt;
		}
	}

# Determine which files to look at
$max = 0;
open(F,"< $dir/x.kook/high.article.number") || die;
$max = readline(F);
print "Max: $max\n";
close(F);

chdir("$dir/$newsgroup");
opendir(F,".");
@filelist = readdir(F);
closedir(F);

# Look at those files (newsgroup postings)
foreach $file (@filelist) {
	if($file =~ /^\d+$/ && $file > $max) {
	        lookat($file);
		$max = $file;	
		}
	}

